freeslot("SPR_FNFA", "SPR_FNFS", "S_ARROW_LEFT", "S_ARROW_DOWN", "S_ARROW_UP", "S_ARROW_RIGHT", "MT_FNF_ARROW")
freeslot("S_ARROW_LEFT_BUL", "S_ARROW_DOWN_BUL", "S_ARROW_UP_BUL", "S_ARROW_RIGHT_BUL")
freeslot("S_ARROW_LEFT_HURT", "S_ARROW_DOWN_HURT", "S_ARROW_UP_HURT", "S_ARROW_RIGHT_HURT")
for i = 1, 4
freeslot("S_ARROW_SPLASH_A"..i, "S_ARROW_SPLASH_B"..i, "S_ARROW_SPLASH_C"..i)
end
//freeslot("S_ARROW_HOLD", "S_ARROW_HOLD_END")

mobjinfo[MT_FNF_ARROW] = { //The Arrow Object that is used for: Input Arrow, Press Effects, Def Arrows.
	doomednum = -1,
	spawnstate = S_ARROW_LEFT,
	spawnhealth = 1,
	speed = 0,
	radius = 24*FRACUNIT,
	height = 1*FRACUNIT,
	dispoffset = 0,
	reactiontime = 2,
	mass = 100,
	damage = 0,
	flags = MF_NOGRAVITY|MF_SCENERY
}
states[S_ARROW_LEFT] = {SPR_FNFA, A, 2, nil, 0, 0, S_ARROW_LEFT} //States for Default Arrows
states[S_ARROW_DOWN] = {SPR_FNFA, B, 2, nil, 0, 0, S_ARROW_DOWN}
states[S_ARROW_UP] = {SPR_FNFA, C, 2, nil, 0, 0, S_ARROW_UP}
states[S_ARROW_RIGHT] = {SPR_FNFA, D, 2, nil, 0, 0, S_ARROW_RIGHT}

states[S_ARROW_LEFT_HURT] = {SPR_FNFA, E, 2, nil, 0, 0, S_ARROW_LEFT_HURT} //States for Hurt Arrows
states[S_ARROW_DOWN_HURT] = {SPR_FNFA, F, 2, nil, 0, 0, S_ARROW_DOWN_HURT}
states[S_ARROW_UP_HURT] = {SPR_FNFA, G, 2, nil, 0, 0, S_ARROW_UP_HURT}
states[S_ARROW_RIGHT_HURT] = {SPR_FNFA, H, 2, nil, 0, 0, S_ARROW_RIGHT_HURT}

states[S_ARROW_LEFT_BUL] = {SPR_FNFA, I, 2, nil, 0, 0, S_ARROW_LEFT_BUL} //States for Bullet Arrows
states[S_ARROW_DOWN_BUL] = {SPR_FNFA, J, 2, nil, 0, 0, S_ARROW_DOWN_BUL}
states[S_ARROW_UP_BUL] = {SPR_FNFA, K, 2, nil, 0, 0, S_ARROW_UP_BUL}
states[S_ARROW_RIGHT_BUL] = {SPR_FNFA, L, 2, nil, 0, 0, S_ARROW_RIGHT_BUL}

states[S_ARROW_SPLASH_A1] = {SPR_FNFS, A, 2, nil, 0, 0, S_ARROW_SPLASH_A2} //Arrow splashes
states[S_ARROW_SPLASH_A2] = {SPR_FNFS, B, 2, nil, 0, 0, S_ARROW_SPLASH_A3}
states[S_ARROW_SPLASH_A3] = {SPR_FNFS, C, 2, nil, 0, 0, S_ARROW_SPLASH_A4}
states[S_ARROW_SPLASH_A4] = {SPR_FNFS, D, 2, nil, 0, 0, NULL}

states[S_ARROW_SPLASH_B1] = {SPR_FNFS, E, 2, nil, 0, 0, S_ARROW_SPLASH_B2}
states[S_ARROW_SPLASH_B2] = {SPR_FNFS, F, 2, nil, 0, 0, S_ARROW_SPLASH_B3}
states[S_ARROW_SPLASH_B3] = {SPR_FNFS, G, 2, nil, 0, 0, S_ARROW_SPLASH_B4}
states[S_ARROW_SPLASH_B4] = {SPR_FNFS, H, 2, nil, 0, 0, NULL}

states[S_ARROW_SPLASH_C1] = {SPR_FNFS, I, 2, nil, 0, 0, S_ARROW_SPLASH_C2} //Hurt splash
states[S_ARROW_SPLASH_C2] = {SPR_FNFS, J, 2, nil, 0, 0, S_ARROW_SPLASH_C3}
states[S_ARROW_SPLASH_C3] = {SPR_FNFS, K, 2, nil, 0, 0, S_ARROW_SPLASH_C4}
states[S_ARROW_SPLASH_C4] = {SPR_FNFS, L, 2, nil, 0, 0, NULL}

//states[S_ARROW_HOLD] = {SPR_FNFA, M, 2, nil, 0, 0, S_ARROW_HOLD}
//states[S_ARROW_HOLD_END] = {SPR_FNFA, N, 2, nil, 0, 0, S_ARROW_HOLDEND}

addHook("ThinkFrame", do //Make Arrows Transparent if you completely missed them
	for mo in mobjs.iterate()
		if mo and mo.valid and mo.type == MT_FNF_ARROW
			if mo.scale < (FRACUNIT - FRACUNIT/3)
				mo.frame = $|FF_TRANS90
			end
			if mo.appear //Make notes fade out of nowhere
				mo.appear = $ - 1
				if mo.appear == 10
					mo.frame = $|FF_TRANS90
				end
				if mo.appear == 9
					mo.frame = $|FF_TRANS80
				end
				if mo.appear == 8
					mo.frame = $|FF_TRANS70
				end
				if mo.appear == 7
					mo.frame = $|FF_TRANS60
				end
				if mo.appear == 6
					mo.frame = $|FF_TRANS50
				end
				if mo.appear == 5
					mo.frame = $|FF_TRANS40
				end
				if mo.appear == 4
					mo.frame = $|FF_TRANS30
				end
				if mo.appear == 3
					mo.frame = $|FF_TRANS10
				end
				if mo.appear == 2
					mo.frame = $|FF_TRANS10
				end
				if mo.appear == 1
					mo.appear = 0
					mo.frame = $ & ~(FF_TRANS90|FF_TRANS80|FF_TRANS70|FF_TRANS60|FF_TRANS50|FF_TRANS40|FF_TRANS30|FF_TRANS20|FF_TRANS10)
				end
			end
		end
	end
end)

local DISTARW = 60*FRACUNIT

addHook("MobjThinker", function(mo)
	if mo and mo.target and mo.dirarw
		local addangle = ANGLE_90*mo.dirarw
		
		local gotox = mo.target.x + FixedMul(DISTARW, cos(mo.target.angle+addangle))
		local gotoy = mo.target.y + FixedMul(DISTARW, sin(mo.target.angle+addangle))
		
		P_TeleportMove(mo, gotox, gotoy, mo.target.z+FRACUNIT*2)
		
		/*if mo.arwtype == 5
			mo.spriteyoffset = $ - 5
		end*/
		
		/*if mo.arwtype == 6
			mo.rollangle = $ + 15*ANG1
		elseif mo.arwtype == 7
			mo.rollangle = $ - 15*ANG1
		end*/
		if mo.target.player and mo.target.player.playerstate == PST_DEAD
			P_KillMobj(mo)
		end
	end
end, MT_FNF_ARROW)