local DISTARW = 60*FRACUNIT

local ARW_DEF = 1
local ARW_HURT = 6 //Special Notes
local ARW_BULLET = 7
//local ARW_HOLD = 5 //Hold note (Unused)
local ARW_CUSTOM = 2 //You can edit this note how you want

local LEFT = 1 //This is for easier use
local DOWN = 2
local UP = 4
local RIGHT = 3

local HLEFT = 5 //Hurt notes
local HDOWN = 6
local HUP = 8
local HRIGHT = 7 //They kill you if you press them

local BLEFT = 9 //Bullet notes
local BDOWN = 10
local BUP = 12
local BRIGHT = 11 //You should press them or they kill you (Now you can make accelerant lol)

local CLEFT = 21 //Custom notes
local CDOWN = 22
local CUP = 24
local CRIGHT = 23 //This is a custom note that you can customize!

/*local LLEFT = 13 //Hold notes
local LDOWN = 14
local LUP = 16
local LRIGHT = 15 //Hold them (They are just like normal ones)

local LLEFTE = 17 //Hold note ends
local LDOWNE = 18
local LUPE = 20
local LRIGHTE = 19*/

local dirtocolor = { //Convert Direction to color (Arrow Splashes only use the 1-4 colors)
	[1] = SKINCOLOR_PURPLE, //Normal Arrows
	[2] = SKINCOLOR_BLUE,
	[4] = SKINCOLOR_GREEN,
	[3] = SKINCOLOR_RED,
	
	[5] = SKINCOLOR_RED, //Hurt Arrows
	[6] = SKINCOLOR_RED,
	[8] = SKINCOLOR_RED,
	[7] = SKINCOLOR_RED,
	
	[9] = SKINCOLOR_YELLOW, //Bullet Arrows
	[10] = SKINCOLOR_YELLOW,
	[12] = SKINCOLOR_YELLOW,
	[11] = SKINCOLOR_YELLOW, 
	
	[21] = SKINCOLOR_WHITE, //Custom Arrows
	[22] = SKINCOLOR_SKY,
	[24] = SKINCOLOR_BLUE,
	[23] = SKINCOLOR_BLACK, 
	
	/*[13] = SKINCOLOR_PURPLE, //Hold Arrows
	[14] = SKINCOLOR_BLUE,
	[16] = SKINCOLOR_GREEN,
	[15] = SKINCOLOR_RED,*/
}

local dodgeanims = { //Dodge Anims for Bullet Arrow
	[9] = S_PLAY_SPINDASH,
	[10] = S_PLAY_SPINDASH,
	[12] = S_PLAY_SPINDASH,
	[11] = S_PLAY_SPINDASH, 
}

local dirtostate = { //Convert Direction to state (So notes would be Left, Down, Up, Right)
	[1] = S_ARROW_LEFT, //Normal Arrows
	[2] = S_ARROW_DOWN,
	[4] = S_ARROW_UP,
	[3] = S_ARROW_RIGHT,
	
	[5] = S_ARROW_LEFT_HURT, //Hurt Arrows
	[6] = S_ARROW_DOWN_HURT,
	[8] = S_ARROW_UP_HURT,
	[7] = S_ARROW_RIGHT_HURT,
	
	[9] = S_ARROW_LEFT_BUL, //Bullet Arrows
	[10] = S_ARROW_DOWN_BUL,
	[12] = S_ARROW_UP_BUL,
	[11] = S_ARROW_RIGHT_BUL,
	
	[21] = S_ARROW_LEFT, //Custom Arrows
	[22] = S_ARROW_DOWN_BUL,
	[24] = S_ARROW_UP_HURT,
	[23] = S_ARROW_RIGHT,
	
	/*[13] = S_ARROW_HOLD, //Hold Arrows
	[14] = S_ARROW_HOLD,
	[16] = S_ARROW_HOLD,
	[15] = S_ARROW_HOLD,
	
	[17] = S_ARROW_HOLD_END, //Hold end Arrows
	[18] = S_ARROW_HOLD_END,
	[20] = S_ARROW_HOLD_END,
	[19] = S_ARROW_HOLD_END*/
}

local spectodir = { //Add your arrows here
	[1] = 1, //Normal Arrows
	[2] = 2,
	[4] = 4,
	[3] = 3,
	
	[5] = 1, //Hurt Arrows
	[6] = 2,
	[8] = 4,
	[7] = 3,
	
	[9] = 1, //Bullet Arrows
	[10] = 2,
	[12] = 4,
	[11] = 3,
	
	[21] = 1, //Custom Arrows
	[22] = 2,
	[24] = 4,
	[23] = 3,
}

local splashrandom = {S_ARROW_SPLASH_A1 , S_ARROW_SPLASH_B1}

rawset(_G, "FNF_SpawnArrow", function(mo, dir, speed, arwtype) //Spawn arrows function
	//if mo and mo.valid
		local addangle = ANGLE_90*dir
		
		local gotox = FixedMul(DISTARW, cos(mo.angle+addangle))
		local gotoy = FixedMul(DISTARW, sin(mo.angle+addangle))
		
		local arrow = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*2, MT_FNF_ARROW)
		arrow.scale = FRACUNIT*2
		arrow.fuse = 150
		arrow.destscale = -1
		arrow.scalespeed = speed
		arrow.color = dirtocolor[dir]
		arrow.flags2 = $|MF2_SPLAT
		arrow.state = dirtostate[dir]
		arrow.appear = 10
		arrow.frame = $|FF_TRANS90
		arrow.target = mo
		arrow.dirarw = dir
		if arwtype == ARW_DEF
			arrow.arwtype = ARW_DEF
		end
		if arwtype == ARW_BULLET
			arrow.arwtype = ARW_BULLET
		end
		if arwtype == ARW_HURT
			arrow.arwtype = ARW_HURT
		end
		
		if arwtype == ARW_CUSTOM //You add these 3 lines with your arrow
			arrow.arwtype = ARW_CUSTOM
		end
		
		/*if dir == 1
			mo.leftarw = arrow
		elseif dir == 2
			mo.downarw = arrow
		elseif dir == 4
			mo.uparw = arrow
		elseif dir == 3
			mo.rightarw = arrow
		end*/
		
		if dir >= 1 and dir <= 4
			arrow.arwtype = ARW_DEF
		end
		
		if dir >= 5 and dir <= 8 //This is for easier charting
			arrow.arwtype = ARW_HURT
		end
		
		if dir >= 9  and dir <= 12 //This too
			arrow.arwtype = ARW_BULLET
		end
		
		if dir >= 21  and dir <= 24 //Then beetween which numbers your arrows are for easier charting
			arrow.arwtype = ARW_CUSTOM
		end
	//end
end)

local SICKL = FRACUNIT - FRACUNIT/10
local SICKE = FRACUNIT + FRACUNIT/10

local LATE =  FRACUNIT - FRACUNIT/5//Press timings
local EARLY = FRACUNIT + FRACUNIT/3 //Use them by scale because it checks the scale for hitting 

freeslot("sfx_bulnot")                                                                                  
rawset(_G, "FNF_PressArrow", function(mo, dir, hold) //Function for pressing arrows  
	for mobj in mobjs.iterate()
		if mobj and mobj.valid
		and mobj.type == MT_FNF_ARROW
		and (mobj.scale <= EARLY and mobj.scale >= LATE)
		and mobj.target == mo and dir == spectodir[mobj.dirarw]
				
				local addangle = ANGLE_90*mobj.dirarw //Use this for notes in order: 1-Left, 2-Down, 3-Right, 4-Up.
				
				local gotox = FixedMul(DISTARW, cos(mo.angle+addangle))
				local gotoy = FixedMul(DISTARW, sin(mo.angle+addangle))
				
				local arrow = P_SpawnMobjFromMobj(mo, gotox, gotoy, ((FRACUNIT*3) + (FRACUNIT/50)), MT_FNF_ARROW)
				arrow.scale = FRACUNIT
				arrow.fuse = 5
				arrow.destscale = FRACUNIT + FRACUNIT/3
				arrow.scalespeed = FRACUNIT/7
				arrow.color = mobj.color
				arrow.blendmode = AST_ADD
				arrow.flags2 = $|MF2_SPLAT
				arrow.state = dirtostate[mobj.dirarw]
				//P_SetObjectMomZ(arrow, -FRACUNIT/5)
				
				if (mobj.scale <= SICKE and mobj.scale >= SICKL)
					local splash = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*5, MT_FNF_ARROW) //Arrow splashes
					splash.scale = FRACUNIT - FRACUNIT/3
					splash.fuse = 15
					splash.color = dirtocolor[mobj.dirarw]
					splash.flags2 = $|MF2_SPLAT
					if mobj.arwtype and mobj.arwtype == ARW_HURT
						splash.state = S_ARROW_SPLASH_C1
					else
						local sran = P_RandomRange(1, 2)
						splash.state = splashrandom[sran]
					end
				elseif (mobj.arwtype and mobj.arwtype == ARW_HURT)	//Then you can copy this if you want a special splash
					local splash = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*5, MT_FNF_ARROW) //Arrow splashes
					splash.scale = FRACUNIT - FRACUNIT/3
					splash.fuse = 15
					splash.color = dirtocolor[mobj.dirarw]
					splash.flags2 = $|MF2_SPLAT
					splash.state = S_ARROW_SPLASH_C1
				end
				
				if mobj.arwtype
					if mobj.arwtype == ARW_HURT
						mo.player.rings = 0
						P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
						if splash and splash.valid //Check it
							splash.color = SKINCOLOR_RED //Set splash color manually
							splash.state = S_ARROW_SPLASH_C1
						end	
					end
					if mobj.arwtype == ARW_BULLET
						S_StartSound(mo, sfx_bulnot)
						mo.state = dodgeanims[mobj.dirarw]
						mo.dodgetics = 15 //This is the amount of tics you are gonna be in the Dodge anim
						mo.player.powers[pw_flashing] = 15 //You cant get be damaged while dodging
						if splash and splash.valid
							splash.color = SKINCOLOR_YELLOW
						end	
					end
					if mobj.arwtype == ARW_CUSTOM //Add properties for pressing it
						mo.color = P_RandomRange(1, #skincolors-1)
					end
					mobj.ded = true
					P_KillMobj(mobj, nil, nil)
				end
		end	
	end	
end)

rawset(_G, "FNF_SpawnInputs", function(mo, dir) //Input Arrows
		for i = 1, 4
			local addangle = ANGLE_90*i
			
			local gotox = FixedMul(DISTARW, cos(mo.angle+addangle))
			local gotoy = FixedMul(DISTARW, sin(mo.angle+addangle))
			
			local arrow = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*3, MT_FNF_ARROW)
			arrow.scale = FRACUNIT
			arrow.fuse = 2
			arrow.color = SKINCOLOR_GREY
			arrow.flags2 = $|MF2_SPLAT
			arrow.state = dirtostate[i]
			arrow.frame = $|FF_TRANS20
			if dir //Make arrows smaller when you press a note or dont (You can delete this if you dont need it)
				if dir == 1 and i == 1
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				elseif dir == 2 and i == 2
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				elseif dir == 4 and i == 4
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				elseif dir == 3 and i == 3
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				end
			end
			/*if dir 
				for mobj in mobjs.iterate() //And make arrows bigger and light up if you hit a note
					if mobj and mobj.valid
					and mobj.type == MT_FNF_ARROW
					and (mobj.scale <= EARLY and mobj.scale >= LATE)
					and mobj.dirarw and mobj.target == mo
					and (mobj.dirarw == dir or dir == mobj.dirarw)
					and (mobj.dirarw == i and dir == i)
						arrow.scale = FRACUNIT + FRACUNIT/5
						arrow.blendmode = AST_ADD
						arrow.color = dirtocolor[i]
					else
						arrow.scale = FRACUNIT - FRACUNIT/5
						arrow.color = SKINCOLOR_SILVER
					end
				end	
			end*/
		end	
end)

freeslot("sfx_miss1", "sfx_miss2", "sfx_miss3") //Miss Sounds

rawset(_G, "FNF_NoteCheck", function(mo) //Arrow checks (for stuff like misses)
	if mo.player 
		local misssound = P_RandomRange(1, 3)
		local misssounds = {sfx_miss1,sfx_miss2,sfx_miss3} //There are the miss sounds, if you add more sounds it will play a random one out of these
		for mobj in mobjs.iterate()
			if mobj and mobj.valid
			and mobj.type == MT_FNF_ARROW
			and mobj.dirarw and mobj.target == mo
			and not mobj.ded
				if mobj.scale < LATE
				and mobj.scale >= LATE-FRACUNIT/15
					if mobj.arwtype == ARW_BULLET //If you miss you lose rings or die
						S_StartSound(mo, sfx_bulnot)
						if mo.player.rings >= 10
							mo.player.rings = $ - 10
						else
							P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
							mo.shootdeathanim = true //Funni death anim
							mo.shootroll = P_RandomRange(-30, 30)
							P_SetObjectMomZ(mo, 5*FRACUNIT)
							if mobj.dirarw == BLEFT
								P_InstaThrust(mo, mo.angle + ANGLE_90, 30*FRACUNIT)
							end
							if mobj.dirarw == BDOWN
								P_InstaThrust(mo, mo.angle - ANGLE_180, 30*FRACUNIT)
							end
							if mobj.dirarw == BUP
								P_InstaThrust(mo, mo.angle, 30*FRACUNIT)
							end
							if mobj.dirarw == BRIGHT
								P_InstaThrust(mo, mo.angle - ANGLE_90, 30*FRACUNIT)
							end
						end 
						
						local exp = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_EXPLODE) 
						exp.scale = FRACUNIT/3 //Smol Bullet explosion
					end 
					if mobj.arwtype != ARW_HURT 
					and mobj.arwtype != ARW_BULLET //This exists because bullet and miss sound doesnt work good
					and mobj.arwtype != ARW_CUSTOM
						if mo.player.rings > 0 
							mo.player.rings = $ - 1
						else
							P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
						end
						mo.player.miss = 5 //Miss timer just idk why (maybe you need it)
					end	
					if mobj.arwtype == ARW_CUSTOM //Add properties for missing your arrow
						S_StartSound(mo, sfx_itemup) //Edit the miss thing above if it has a penality for missing it or not
						mo.player.rings = $ + P_RandomRange(2, 15)
						mo.customvar = 15
					end 
					mobj.target = nil
				end
			end	
		end	
		if mo.player.miss
			mo.player.miss = $ - 1
			if mo.player.miss >= 4
				S_StartSound(mo, misssounds[misssound]) //Miss sound
			end
		end
		/*if mo.player.holdleft
			mo.player.holdleft = $ - 1
		end
		if mo.player.holddown
			mo.player.holddown = $ - 1
		end
		if mo.player.holdup
			mo.player.holdup = $ - 1
		end
		if mo.player.holdright
			mo.player.holdright = $ - 1
		end*/
	end	
end)

addHook("ThinkFrame", do //Make player transparent so you can see notes clearer
	for mo in mobjs.iterate()
		if mo and mo.valid and mo.player
			if mo.shootdeathanim and mo.shootroll and mo.player.playerstate == PST_DEAD //Speeeen
				mo.rollangle = $ + mo.shootroll*ANG1
				if P_IsObjectOnGround(mo)
					if mo.rollangle >= 0
						mo.rollangle = ANGLE_90
					else
						mo.rollangle = -ANGLE_90
					end	
					if R_PointToDist2(0, 0, mo.momx, mo.momy) >= 15*FRACUNIT
						local ranx = FixedMul(P_RandomRange(-mo.height/FRACUNIT, mo.height/FRACUNIT)*FRACUNIT, cos(P_RandomRange(0, 360)*ANG1))
						local rany = FixedMul(P_RandomRange(-mo.height/FRACUNIT, mo.height/FRACUNIT)*FRACUNIT, sin(P_RandomRange(0, 360)*ANG1))
						local dust = P_SpawnMobjFromMobj(mo, ranx, rany, FRACUNIT, MT_DUST)
					end
				end
			end
			if mo.customvar //And maybe something more
				mo.customvar = $ - 1
				mo.color = P_RandomRange(1, #skincolors-1)
				if mo.customvar == 1
					mo.customvar = 0
					mo.color = mo.player.skincolor
				end
			end
			if mo.dodgetics //Dodge anim if you have one
				mo.dodgetics = $ - 1 //Just delete this if you dont need it
				if mo.dodgetics == 1
					mo.dodgetics = 0
					for i = 1, 18
						if mo.state == dodgeanims[i] //Revert back to standing when done dodging
							mo.state = S_PLAY_STND
						end
					end
				end	
			end
			if displayplayer == mo.player
				if mo.player.fnf
					mo.frame = $|FF_TRANS70
					mo.transgender = true
				else
					if mo.transgender
						mo.transgender = false
						mo.frame = $ & ~FF_TRANS70
					end
				end
			end	
		end
	end
end)

addHook("MobjDeath", function(mo) //Reset FNF variables when dying and respawning
	if mo.player
		if mo.player.fnf
			mo.player.fnf = false
		end
		mo.player.time = -1
		mo.player.miss = 0
	end
end, MT_PLAYER)

addHook("PlayerSpawn", function(player)
	if player
		if player.fnf
			player.fnf = false
		end
		player.time = -1
		player.miss = 0
	end
end)

local chart = { //Chart Stuff Here
HLEFT,0, //Special notes check
BDOWN,0,
CUP,0, //And finishing touch... add it to your chart!
RIGHT,0,
0,0,0,0,0,
LEFT, //notes spawns every 20 tics (player.time%20)
0,
RIGHT,
0,
0,
LEFT,
0,
RIGHT,
0, //This makes a pause beetween notes
0,
0,
UP,
0,
DOWN,0,0,
UP,0,
DOWN,0,0,0,
LEFT,0,
UP,0,
DOWN,0,
RIGHT,0,0,0,
DOWN,0,
DOWN,0,
UP,0,0,
DOWN,0,
DOWN,0,
RIGHT,0,0,0,
DOWN,
UP,
RIGHT,
UP,0,0,
RIGHT,0,0,
RIGHT,0,
RIGHT,0,
DOWN,0,
LEFT,0,
DOWN,0,
UP,0,
RIGHT,0,
LEFT,0,
UP,0,
DOWN, //Now long notes are actually possible because new input system
DOWN, //But they are still like this...
DOWN,0,0,0,0,
0,0,
LEFT,
DOWN,
UP,
RIGHT,
UP,
DOWN,
LEFT,
DOWN,
UP,
RIGHT,
UP,
RIGHT,
UP,
RIGHT,
DOWN,
LEFT,0,0,0,0,0} //I tried to chart the Tutorial from the Original. Should be accurate but the timings are a bit off.

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if player.fnf
			if (leveltime%20) == 0 //I recommend this stuff below for FNF stuff for now.
				player.time = $ + 1
				player.use = true
			else
				player.use = false
			end	
			FNF_NoteCheck(player.mo) //Run every tic
			if chart and chart[player.time%#chart+1]
			and player.use //But it wont stop the "FNF mode"
				FNF_SpawnArrow(player.mo, chart[player.time%#chart+1], FRACUNIT/35) //This thing spawns notes
			end
			if chart and (player.time >= #chart-1) //A reward for completing the song
				player.fnf = false //Also stops the song
				player.time = -1 //and resets it
				player.powers[pw_invulnerability] = TICRATE*60
			end
			if player.cmd.sidemove <= -25 //Inputs (if you dont like it you can change it)
				if not player.left
					FNF_PressArrow(player.mo, 1)
				end	
				FNF_SpawnInputs(player.mo, 1)
				player.left = true
			else
				if player.left
					player.holdleft = 0
				end
				player.left = false
			end
			if player.cmd.forwardmove <= -25
				if not player.down
					FNF_PressArrow(player.mo, 2)
				end	
				FNF_SpawnInputs(player.mo, 2)
				player.down = true
			else
				if player.down
					player.holddown = 0
				end
				player.down = false
			end
			if player.cmd.forwardmove >= 25
				if not player.up
					FNF_PressArrow(player.mo, 4)
				end	
				FNF_SpawnInputs(player.mo, 4)
				player.up = true
			else
				if player.up
					player.holdup = 0
				end
				player.up = false
			end
			if player.cmd.sidemove >= 25
				if not player.right
					FNF_PressArrow(player.mo, 3)
				end	
				FNF_SpawnInputs(player.mo, 3)
				player.right = true
			else
				if player.right
					player.holdright = 0
				end
				player.right = false
			end
			if not (player.cmd.sidemove or player.cmd.forwardmove)
				FNF_SpawnInputs(player.mo)
			end
		end
		if player.cmd.buttons & BT_CUSTOM3 //Placeholders for activating "FNF mode"
			if not player.c3
				player.fnf = true
				player.time = -1
			end
			player.c3 = true
		else
			player.c3 = false
		end
		/*if player.cmd.buttons & BT_TOSSFLAG
			if not player.ts
				player.fnf = false
				player.time = -1
			end
			player.ts = true
		else
			player.ts = false
		end*/
	end
end)